import 'package:airpay_emar_package/airpay_package.dart';
import 'package:airpay_emar_package/model/CardDetailResponse.dart';
import 'package:airpay_emar_package/model/QrDecryptResponse.dart';
import 'package:airpay_emar_package/screens/airpay_UAE.dart';
import 'package:airpay_emar_package/screens/cardDetails.dart';
import 'package:airpay_emar_package/screens/QRDecrypt.dart';
import 'package:awesome_dialog/awesome_dialog.dart';
import 'package:email_validator/email_validator.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';

class Home extends StatefulWidget {
  final bool isSandbox;
  Home({required this.isSandbox});

  @override
  _HomeState createState() => _HomeState(isSandbox: isSandbox);
}

class _HomeState extends State<Home> {
  final bool isSandbox;
  _HomeState({required this.isSandbox});

  var merchantId ="";
  var order_id ="";
  var amount_value="";
  var table_id ="";

  bool isSuccess = false;
  bool isVisible = false;
  TextEditingController fname = TextEditingController();
  TextEditingController lname = TextEditingController();
  TextEditingController email = TextEditingController();
  TextEditingController phone = TextEditingController();
  TextEditingController city = TextEditingController();
  TextEditingController state = TextEditingController();
  TextEditingController country = TextEditingController();
  TextEditingController pincode = TextEditingController();
  TextEditingController orderId = TextEditingController();
  TextEditingController amount = TextEditingController();
  TextEditingController fullAddress = TextEditingController();
  TextEditingController customvar = TextEditingController();

  void _showAddress() {
    setState(() {
      isVisible = !isVisible;
    });
  }

  @override
  void initState() {
    super.initState();

    fname.text = "test";
    lname.text = "test";
    email.text = "k@gmail.com";
    phone.text = "7904254046";
    fullAddress.text = "";
    pincode.text = "000000";
    orderId.text = "0";
    amount.text = "0";
    city.text = "";
    state.text = "";
    country.text = "784";
    customvar.text = "testcustomvar";
  }

  onComplete(status, response) {
    var resp = response.toJson();
    print(resp);
    var txtStsMsg = resp['STATUSMSG'] ?? "";
    var txtSts = resp['TRANSACTIONSTATUS'] ?? "";
    Navigator.pop(context);
    if (txtStsMsg == '') {
      txtStsMsg = response['STATUSMSG'] ?? "";
      txtSts = response['TRANSACTIONSTATUS'] ?? "";
    }
    if (txtStsMsg == 'Invalid Checksum') {
      // txtStsMsg = "Transaction Canceled";
    }

    AwesomeDialog(
            context: context,
            dialogType: DialogType.INFO,
            headerAnimationLoop: true,
            animType: AnimType.BOTTOMSLIDE,
            title: "AirPay",
            desc: 'Transaction Status: ' +
                txtSts +
                '\nTransaction Status Message: ' +
                txtStsMsg)
        .show();
  }

  onCardComplete(bool status,CardDetailResponse response) {
   // var resp = response.toJson();
    Navigator.pop(context);
    print("OnCardComplete --->"+response.result![0].cardstart.toString());
    // var txtStsMsg = resp['STATUSMSG'] ?? "";
    // var txtSts = resp['TRANSACTIONSTATUS'] ?? "";
    // Navigator.pop(context);
    // if (txtStsMsg == '') {
    //   txtStsMsg = response['STATUSMSG'] ?? "";
    //   txtSts = response['TRANSACTIONSTATUS'] ?? "";
    // }
    // if (txtStsMsg == 'Invalid Checksum') {
    //   // txtStsMsg = "Transaction Canceled";
    // }

    AwesomeDialog(
        context: context,
        dialogType: DialogType.INFO,
        headerAnimationLoop: true,
        animType: AnimType.BOTTOMSLIDE,
        title: "AirPay",
        desc: 'CARD RESPONSE: \n'+response.toJson().toString())
        .show();
  }

  onQRComplete(bool status, QrDecryptResponse qrDecryptResponse) {
   // var resp = response.toJson();
   // print(resp);
    Navigator.pop(context);
    //merchantId = qrDecryptResponse.data?.merchantId;


    if(qrDecryptResponse.data !=null){
      merchantId = qrDecryptResponse.data!.merchantId.toString();
      order_id = qrDecryptResponse.data!.orderId.toString();
      amount_value = qrDecryptResponse.data!.amount.toString();
      table_id = qrDecryptResponse.data!.tableId.toString();

      AwesomeDialog(
          context: context,
          dialogType: DialogType.INFO,
          headerAnimationLoop: true,
          animType: AnimType.BOTTOMSLIDE,
          title: "AirPay",
          desc: 'QR DECRYPT RESPONSE: ' +"\n"+
              "Mid - "+qrDecryptResponse.data!.merchantId.toString()+"\n"+"Order Id - "+qrDecryptResponse.data!.orderId.toString()
              +"\n"+"Table Id - "+qrDecryptResponse.data!.tableId.toString()+"\n"+"Amount - "+qrDecryptResponse.data!.amount.toString())
       //desc:'QR DECRYPT RESPONSE: ' +"\n"+ qrDecryptResponse.toString())
          .show() ;
    }
    else{
      AwesomeDialog(
          context: context,
          dialogType: DialogType.INFO,
          headerAnimationLoop: true,
          animType: AnimType.BOTTOMSLIDE,
          title: "AirPay",

       desc:'QR DECRYPT RESPONSE: '+"\n"+ qrDecryptResponse.status.toString() +"\n"+ qrDecryptResponse.message.toString())
          .show() ;
    }

  }

  void ValidateFields(String requestType) {
    var msg = '';
    if (fname.text.length < 2) {
      msg = 'Enter first name';
    } else if (RegExp(r"^[a-zA-Z0-9]+$").hasMatch(fname.text) == false) {
      msg = 'Enter a valid first name';
    } else if (lname.text.isEmpty) {
      msg = 'Enter last name';
    } else if (RegExp(r"^[a-zA-Z0-9]+$").hasMatch(lname.text) == false) {
      msg = 'Enter a valid last name';
    } else if (email.text.isEmpty && phone.text.isEmpty) {
      msg = 'Enter an email ID or phone number';
    } else if (email.text.isNotEmpty &&
        RegExp(r"^[a-zA-Z0-9.a-zA-Z0-9._`{|}~]+@[a-zA-Z0-9]+\.[a-zA-Z]+")
                .hasMatch(email.text) ==
            false) {
      msg = "Please enter a valid email";
    } else if (phone.text.isNotEmpty && phone.text.length < 10) {
      msg = 'Enter a valid phone number';
    }/* else if (orderId.text.isEmpty) {
      msg = 'Enter order ID';
    } else if (amount.text.isEmpty) {
      msg = 'Enter an amount to proceed';
    } else if (amount.text == '0') {
      msg = 'Enter valid amount to proceed';
    }*/

    if (msg.isNotEmpty) {
      AwesomeDialog(
              context: context,
              dialogType: DialogType.ERROR,
              headerAnimationLoop: true,
              animType: AnimType.BOTTOMSLIDE,
              title: "AirPay",
              btnOkOnPress: () {},
              btnOkColor: Colors.red,
              desc: msg)
          .show();
      return;
    }

//Testing Credentails
    String domainPath = 'https://apple.nowpay.co.in/kmmrcetest/success.php';

    String merchantID = '247033'; //'18999';

    UserRequest user = UserRequest(
        /*username: kAirPayUserName,
        password: kAirPayPassword,
        secret: kAirPaySecretKey,*/
        merchantId: merchantId,
        protoDomain: domainPath,
        fname: fname.text,
        lname: lname.text,
        email: email.text,
        phone: phone.text,
        fulladdress: fullAddress.text,
        pincode: pincode.text,
        orderid: order_id,
        amount: amount_value,
        city: city.text,
        state: state.text,
        country: country.text,
        currency: '784', //"356",
        isCurrency: 'AED', //"INR",
        chMode: '', //"",
        customVar: "test",
        txnSubtype: "",
        wallet: "0",
        isStaging: this.isSandbox,
        // successUrl: successURL,
        // failedUrl: failedURL,
        sActionType: 'IndexPay',
        customvar: customvar.text,
        discount: "35.00");

    Navigator.push(
      context,
      MaterialPageRoute(
        builder: (BuildContext context) => new AirPayUAE(
            user: user,
            closure: (status, response) => {onComplete(status, response)}),
      ),
    );
  }

  void ValidateDirectIndexFields(String requestType) {
    var msg = '';
    if (fname.text.length < 2) {
      msg = 'Enter first name';
    } else if (RegExp(r"^[a-zA-Z0-9]+$").hasMatch(fname.text) == false) {
      msg = 'Enter a valid first name';
    } else if (lname.text.isEmpty) {
      msg = 'Enter last name';
    } else if (RegExp(r"^[a-zA-Z0-9]+$").hasMatch(lname.text) == false) {
      msg = 'Enter a valid last name';
    } else if (email.text.isEmpty && phone.text.isEmpty) {
      msg = 'Enter an email ID or phone number';
    } else if (email.text.isNotEmpty &&
        RegExp(r"^[a-zA-Z0-9.a-zA-Z0-9._`{|}~]+@[a-zA-Z0-9]+\.[a-zA-Z]+")
            .hasMatch(email.text) ==
            false) {
      msg = "Please enter a valid email";
    } else if (phone.text.isNotEmpty && phone.text.length < 10) {
      msg = 'Enter a valid phone number';
    }/* else if (orderId.text.isEmpty) {
      msg = 'Enter order ID';
    } else if (amount.text.isEmpty) {
      msg = 'Enter an amount to proceed';
    } else if (amount.text == '0') {
      msg = 'Enter valid amount to proceed';
    }*/

    if (msg.isNotEmpty) {
      AwesomeDialog(
          context: context,
          dialogType: DialogType.ERROR,
          headerAnimationLoop: true,
          animType: AnimType.BOTTOMSLIDE,
          title: "AirPay",
          btnOkOnPress: () {},
          btnOkColor: Colors.red,
          desc: msg)
          .show();
      return;
    }

    String domainPath ='https://apple.nowpay.co.in/kmmrcetest/success.php';

    String kAirPaySecretKey = 'hgrTsTTUrH7xvRN9';//'RbVqe3xTjiwvlYCB'; 18999

    String kAirPayUserName = '5326492';//'2374952'; // 18999

    String kAirPayPassword = 'c3Tpjp7A';// 'EpSl3xNJ'; 18999

    String merchantID = '247033'; //'18999';

    String successURL =
        'https://apple.nowpay.co.in/kmmrcetest/success.php';//'https://apple.nowpay.co.in/airpay_php_v3/responsefromairpay.php'; - 18999

    String failedURL =
        'https://apple.nowpay.co.in/kmmrcetest/success.php'; //'https://apple.nowpay.co.in/airpay_php_v3/responsefromairpay.php'; 18999

    UserRequest user = UserRequest(
      /*  username: kAirPayUserName,
        password: kAirPayPassword,
        secret: kAirPaySecretKey,*/
        merchantId: merchantId,
        protoDomain: domainPath,
        fname: fname.text,
        lname: lname.text,
        email: email.text,
        phone: phone.text,
        fulladdress: fullAddress.text,
        pincode: pincode.text,
        orderid: order_id,
        amount: amount_value,
        city: city.text,
        state: state.text,
        country: country.text,
        currency: '784', //"356",
        isCurrency: 'AED', //"INR",
        chMode: 'pg', //"",
        customVar: "test",
        txnSubtype: "",
        wallet: "0",
        isStaging: this.isSandbox,
        successUrl: successURL,
        failedUrl: failedURL,
        expiryMM:'12',
        expiryYY: '29',
        sChannel: 'pg',
        cardCVV: '756',
        cardNum: '4591500000000055',
        sActionType: 'DirectPay',
        customvar: customvar.text,
        discount: "35.00");

    Navigator.push(
      context,
      MaterialPageRoute(
        builder: (BuildContext context) => new AirPayUAE(
            user: user,
            closure: (status, response) => {onComplete(status, response)}),
      ),
    );
  }

  void getCardDetails(){
    UserRequest user = UserRequest(
        email: email.text,
        phone: phone.text,
        sActionType: 'FetchCards');


    Navigator.push(
      context,
      MaterialPageRoute(
        builder: (BuildContext context) => new CardDetails(
            user: user,
            cardDetailClosure: (status, response) => {onCardComplete(status,response)}),
      ),
    );
  }

  void getQrDecrypt(){
    UserRequest user = UserRequest(
        query: '4e5c33e325357d6d|be371ea37938e94fbcbd20efcac75e8e34a159303e9a88df87dbd3619f88545c77d4262110d7333b462b5ab08f3942f0d8545382505216239d6143de734b6602ad2ecd0d59c5a8f292b6058d7b9cb34c36b875d333e2ad42c3da287f6a9c3fdff3b33c86798d7dde53e72e1ad83cea1b',  //qr String
        sActionType: 'QRDecrypt');


    Navigator.push(
      context,
      MaterialPageRoute(
        builder: (BuildContext context) => new QRDecrypt(
            user: user,
            qrDecryptClosure: (status,response) => {onQRComplete(status,response)}),
      ),
    );
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
        appBar: AppBar(
          centerTitle: true,
          title: Image.asset(
            'assets/airpays.png',
            height: 40,
            color: Colors.white,
            width: 200,
          ),
          backgroundColor: Colors.blue[900],
        ),
        backgroundColor: Colors.grey[400],
        body: SafeArea(
          child: SingleChildScrollView(
            child: Column(
              crossAxisAlignment: CrossAxisAlignment.stretch,
              children: [
                Card(
                  margin: EdgeInsets.fromLTRB(8.0, 8, 8.0, 4),
                  color: Colors.white,
                  child: Padding(
                    padding: const EdgeInsets.fromLTRB(12.0, 2.0, 12.0, 15.0),
                    child: Column(
                      mainAxisAlignment: MainAxisAlignment.center,
                      crossAxisAlignment: CrossAxisAlignment.stretch,
                      children: [
                        Text(
                          'Personal Information',
                          style: TextStyle(
                              fontSize: 20.0,
                              color: Colors.blue[900],
                              fontWeight: FontWeight.bold),
                        ),
                        SizedBox(
                          height: 15.0,
                        ),
                        Row(
                          children: [
                            Expanded(
                                child: Text(
                              'First Name *',
                              style: TextStyle(
                                  fontSize: 18.0, color: Colors.blue[900]),
                            )),
                            SizedBox(
                              width: 10.0,
                            ),
                            Expanded(
                              child: Text(
                                'Last Name *',
                                style: TextStyle(
                                    fontSize: 18.0, color: Colors.blue[900]),
                              ),
                            ),
                          ],
                        ),
                        Row(
                          children: [
                            Expanded(
                                child: TextFormField(
                              inputFormatters: [
                                // FilteringTextInputFormatter.allow(RegExp(r'^[a-zA-Z0-9]+$')),
                                new LengthLimitingTextInputFormatter(18),
                              ],
                              keyboardType: TextInputType.name,
                              decoration: InputDecoration(
                                hintText: 'First Name',
                                //   contentPadding: EdgeInsets.all(2.0),
                                hintStyle: TextStyle(
                                    color: Colors.grey, fontSize: 15.0),
                              ),
                              controller: fname,
                            )),
                            SizedBox(
                              width: 10.0,
                            ),
                            Expanded(
                              child: TextFormField(
                                inputFormatters: [
                                  // FilteringTextInputFormatter.allow(RegExp(r'^[a-zA-Z0-9]+$')),
                                  new LengthLimitingTextInputFormatter(18),
                                ],
                                keyboardType: TextInputType.name,
                                decoration: InputDecoration(
                                  hintText: 'Last Name',
                                  // contentPadding: EdgeInsets.all(2.0),
                                  hintStyle: TextStyle(
                                      color: Colors.grey, fontSize: 15.0),
                                ),
                                controller: lname,
                              ),
                            ),
                          ],
                        ),
                        SizedBox(
                          height: 8.0,
                        ),
                        Container(
                          child: TextFormField(
                            validator: (value) => EmailValidator.validate(value!)
                                ? null
                                : "Please enter a valid email",
                            keyboardType: TextInputType.emailAddress,
                            decoration: InputDecoration(
                              hintText: 'Email Id',
                              // contentPadding: EdgeInsets.all(2.0),
                              hintStyle:
                                  TextStyle(color: Colors.grey, fontSize: 15.0),
                            ),
                            controller: email,
                          ),
                        ),
                        SizedBox(
                          height: 8.0,
                        ),
                        Container(
                          child: TextFormField(
                            keyboardType: TextInputType.number,
                            inputFormatters: <TextInputFormatter>[
                              new LengthLimitingTextInputFormatter(
                                  10), // for mobile
                              FilteringTextInputFormatter.digitsOnly
                            ], // Only numbers can be entered
                            decoration: InputDecoration(
                              hintText: 'Phone',
                              // contentPadding: EdgeInsets.all(2.0),
                              hintStyle:
                                  TextStyle(color: Colors.grey, fontSize: 15.0),
                            ),
                            controller: phone,
                          ),
                        ),
                        SizedBox(
                          height: 15.0,
                        ),
                        Container(
                          child: TextFormField(
                            keyboardType: TextInputType.number,
                            inputFormatters: <TextInputFormatter>[
                              new LengthLimitingTextInputFormatter(
                                  10), // for mobile
                              FilteringTextInputFormatter.singleLineFormatter
                            ], // Only numbers can be entered
                            decoration: InputDecoration(
                              hintText: 'CustomVar',
                              // contentPadding: EdgeInsets.all(2.0),
                              hintStyle:
                              TextStyle(color: Colors.grey, fontSize: 15.0),
                            ),
                            controller: customvar,
                          ),
                        ),
                        SizedBox(
                          height: 15.0,
                        ),
                      ],
                    ),
                  ),
                ),
                Visibility(
                    visible: true,
                    child: Card(
                      margin: EdgeInsets.fromLTRB(8.0, 8, 8.0, 4),
                      color: Colors.white,
                      child: Padding(
                          padding: EdgeInsets.fromLTRB(8.0, 8, 8.0, 4),
                          child: Column(
                            children: [
                              Row(
                                mainAxisAlignment:
                                    MainAxisAlignment.spaceBetween,
                                children: [
                                  Text(
                                    'Address',
                                    style: TextStyle(
                                        color: Colors.blue[900],
                                        fontSize: 20.0,
                                        fontWeight: FontWeight.bold),
                                  ),
                                  IconButton(
                                    onPressed: () {
                                      _showAddress();
                                    },
                                    icon: isVisible
                                        ? Icon(Icons.arrow_drop_up)
                                        : Icon(Icons.arrow_drop_down),
                                    color: Colors.black,
                                  )
                                ],
                              ),
                              Visibility(
                                visible: isVisible,
                                child: Column(
                                  mainAxisAlignment: MainAxisAlignment.center,
                                  crossAxisAlignment:
                                      CrossAxisAlignment.stretch,
                                  children: [
                                    Container(
                                      child: TextFormField(
                                        inputFormatters: <TextInputFormatter>[
                                          //  FilteringTextInputFormatter.allow(RegExp(r'(^[0-9]{0,7}(?:\.[0-9]{0,2})?)')),

                                          new LengthLimitingTextInputFormatter(
                                              254),
                                        ],
                                        keyboardType: TextInputType.text,
                                        decoration: InputDecoration(
                                          hintText: 'Full Address',
                                          // contentPadding: EdgeInsets.all(2.0),
                                          hintStyle: TextStyle(
                                              color: Colors.grey,
                                              fontSize: 15.0),
                                        ),
                                        controller: fullAddress,
                                      ),
                                    ),
                                    SizedBox(
                                      height: 8.0,
                                    ),
                                    Container(
                                      child: TextFormField(
                                        inputFormatters: <TextInputFormatter>[
                                          //  FilteringTextInputFormatter.allow(RegExp(r'(^[0-9]{0,7}(?:\.[0-9]{0,2})?)')),

                                          new LengthLimitingTextInputFormatter(
                                              18),
                                        ],
                                        keyboardType: TextInputType.text,
                                        decoration: InputDecoration(
                                          hintText: 'City Name',
                                          // contentPadding: EdgeInsets.all(2.0),
                                          hintStyle: TextStyle(
                                              color: Colors.grey,
                                              fontSize: 15.0),
                                        ),
                                        controller: city,
                                      ),
                                    ),
                                    SizedBox(
                                      height: 8.0,
                                    ),
                                    Row(
                                      children: [
                                        Expanded(
                                            child: Text(
                                          'State Name',
                                          style: TextStyle(
                                              fontSize: 18.0,
                                              color: Colors.blue[900]),
                                        )),
                                        SizedBox(
                                          width: 8.0,
                                        ),
                                        Expanded(
                                          child: Text(
                                            'Country Name',
                                            style: TextStyle(
                                                fontSize: 18.0,
                                                color: Colors.blue[900]),
                                          ),
                                        ),
                                      ],
                                    ),
                                    Row(
                                      children: [
                                        Expanded(
                                            child: TextFormField(
                                          inputFormatters: <TextInputFormatter>[
                                            //  FilteringTextInputFormatter.allow(RegExp(r'(^[0-9]{0,7}(?:\.[0-9]{0,2})?)')),

                                            new LengthLimitingTextInputFormatter(
                                                18),
                                          ],
                                          keyboardType: TextInputType.name,
                                          decoration: InputDecoration(
                                            hintText: 'State',
                                            //   contentPadding: EdgeInsets.all(2.0),
                                            hintStyle: TextStyle(
                                                color: Colors.grey,
                                                fontSize: 15.0),
                                          ),
                                          controller: state,
                                        )),
                                        SizedBox(
                                          width: 10.0,
                                        ),
                                        Expanded(
                                          child: TextFormField(
                                            inputFormatters: <
                                                TextInputFormatter>[
                                              //  FilteringTextInputFormatter.allow(RegExp(r'(^[0-9]{0,7}(?:\.[0-9]{0,2})?)')),

                                              new LengthLimitingTextInputFormatter(
                                                  18),
                                            ],
                                            keyboardType: TextInputType.name,
                                            decoration: InputDecoration(
                                              hintText: 'Country ',
                                              // contentPadding: EdgeInsets.all(2.0),
                                              hintStyle: TextStyle(
                                                  color: Colors.grey,
                                                  fontSize: 15.0),
                                            ),
                                            controller: country,
                                          ),
                                        ),
                                      ],
                                    ),
                                    SizedBox(
                                      height: 8.0,
                                    ),
                                    Container(
                                      child: TextFormField(
                                        inputFormatters: <TextInputFormatter>[
                                          FilteringTextInputFormatter
                                              .digitsOnly,
                                          new LengthLimitingTextInputFormatter(
                                              8),
                                        ],
                                        keyboardType: TextInputType.number,
                                        decoration: InputDecoration(
                                          hintText: 'PinCode',
                                          // contentPadding: EdgeInsets.all(2.0),
                                          hintStyle: TextStyle(
                                              color: Colors.grey,
                                              fontSize: 15.0),
                                        ),
                                        controller: pincode,
                                      ),
                                    ),
                                    SizedBox(
                                      height: 15.0,
                                    ),
                                  ],
                                ),
                              ),
                            ],
                          )),
                    )),
                Card(
                  margin: EdgeInsets.all(8.0),
                  color: Colors.white,
                  child: Padding(
                    padding: EdgeInsets.all(8.0),
                    child: Column(
                      mainAxisAlignment: MainAxisAlignment.center,
                      crossAxisAlignment: CrossAxisAlignment.stretch,
                      children: [
                        Text(
                          'Transaction Information',
                          style: TextStyle(
                              fontSize: 20.0,
                              color: Colors.blue[900],
                              fontWeight: FontWeight.bold),
                        ),
                        SizedBox(
                          height: 15.0,
                        ),
                        Row(
                          children: [
                            Expanded(
                                child: Text(
                              'Order Id *',
                              style: TextStyle(
                                  fontSize: 18.0, color: Colors.blue[900]),
                            )),
                            SizedBox(
                              width: 8.0,
                            ),
                            Expanded(
                              child: Text(
                                'Amount *',
                                style: TextStyle(
                                    fontSize: 18.0, color: Colors.blue[900]),
                              ),
                            ),
                          ],
                        ),
                        Row(
                          children: [
                            Expanded(
                                child: TextFormField(
                              inputFormatters: [
                                new LengthLimitingTextInputFormatter(8),
                                FilteringTextInputFormatter.allow(
                                    RegExp(r'([a-zA-Z0-9])')),
                              ],
                              keyboardType: TextInputType.name,
                              decoration: InputDecoration(
                                hintText: 'Order Id',
                                //   contentPadding: EdgeInsets.all(2.0),
                                hintStyle: TextStyle(
                                    color: Colors.grey, fontSize: 15.0),
                              ),
                              controller: orderId,
                            )),
                            SizedBox(
                              width: 8.0,
                            ),
                            Expanded(
                              child: TextFormField(
                                inputFormatters: [
                                  FilteringTextInputFormatter.allow(RegExp(
                                      r'(^[0-9]{0,7}(?:\.[0-9]{0,2})?)')),
                                ],
                                keyboardType: TextInputType.number,
                                decoration: InputDecoration(
                                  hintText: 'Amount',
                                  // contentPadding: EdgeInsets.all(2.0),
                                  hintStyle: TextStyle(
                                      color: Colors.grey, fontSize: 15.0),
                                ),
                                controller: amount,
                              ),
                            ),
                          ],
                        ),
                        SizedBox(
                          height: 15.0,
                        ),
                      ],
                    ),
                  ),
                ),

                Container(
                  margin: EdgeInsets.all(8.0),
                  child: ElevatedButton(
                    // padding: EdgeInsets.fromLTRB(2.0, 11.0, 2.0, 11.0),
                    onPressed: () {
                      getQrDecrypt();
                    },
                    // color: Colors.blue[900],
                    child: Text(
                      'QR DECRYPT',
                      style: TextStyle(color: Colors.white, fontSize: 20),
                    ),
                  ),
                ),
                Container(
                  margin: EdgeInsets.all(8.0),
                  child: ElevatedButton(
                    // padding: EdgeInsets.fromLTRB(2.0, 11.0, 2.0, 11.0),
                    onPressed: () {
                      getCardDetails();
                    },
                    // color: Colors.blue[900],
                    child: Text(
                      'GET CARD DETAILS',
                      style: TextStyle(color: Colors.white, fontSize: 20),
                    ),
                  ),
                ),
                Container(
                  margin: EdgeInsets.all(8.0),
                  child: ElevatedButton(
                    // padding: EdgeInsets.fromLTRB(2.0, 11.0, 2.0, 11.0),
                    onPressed: () {
                      ValidateDirectIndexFields('DIRECT PAY');
                    },
                    // color: Colors.blue[900],
                    child: Text(
                      'DIRECT PAY',
                      style: TextStyle(color: Colors.white, fontSize: 20),
                    ),
                  ),
                ),
                Container(
                  margin: EdgeInsets.all(8.0),
                  child: ElevatedButton(
                    // padding: EdgeInsets.fromLTRB(2.0, 11.0, 2.0, 11.0),
                    onPressed: () {
                      ValidateFields('INDEX PAY');
                    },
                    // color: Colors.blue[900],
                    child: Text(
                      'ADD CARD',
                      style: TextStyle(color: Colors.white, fontSize: 20),
                    ),
                  ),
                ),

                Container(
                  margin: EdgeInsets.all(8.0),
                  child: ElevatedButton(
                    // padding: EdgeInsets.fromLTRB(2.0, 11.0, 2.0, 11.0),
                    onPressed: () {
                      Navigator.pop(context);
                    },
                    // color: Colors.blue[900],
                    child: Text(
                      'BACK',
                      style: TextStyle(color: Colors.white, fontSize: 20),
                    ),
                  ),
                )
              ],
            ),
          ),
        ));
  }
}
