
import 'dart:convert';
import 'package:airpay_emar_package/model/CardDetailResponse.dart';
import 'package:airpay_emar_package/model/CardTokenResponse.dart';
import 'package:crypto/crypto.dart';
import 'package:flutter/material.dart';
import 'package:airpay_emar_package/model/Transaction.dart';
import 'package:airpay_emar_package/model/UserRequest.dart';
import 'package:dio/dio.dart';
import 'package:flutter_spinkit/flutter_spinkit.dart';

typedef void CallBack(CARDDETAILS response);
//typedef void Closure(bool val, Transaction response);
typedef void CardDetailClosure(bool val, CardDetailResponse response);

class CardDetails extends StatefulWidget {
  final CardDetailClosure? cardDetailClosure;
  final UserRequest user;

  CardDetails({Key? key, required this.user,this.cardDetailClosure}) : super(key: key);
  @override
  _CardDetailsState createState() => new _CardDetailsState();
}

class _CardDetailsState extends State<CardDetails> {
  bool isShowProgress = true;
  var privatekey;
  var email;
  var mobileNo;
  var tokenData;
  var merchantId;


  @override
  void initState() {
    super.initState();
    // var user = widget.user;
    email = widget.user.email;
    mobileNo = widget.user.phone;

    String kAirPaySecretKey = 'hgrTsTTUrH7xvRN9';
    String kAirPayUserName = '5326492';
    String kAirPayPassword = 'c3Tpjp7A';
    merchantId = "247033";

    var temp = utf8.encode(
        '$kAirPaySecretKey@$kAirPayUserName:|:$kAirPayPassword');
    privatekey = sha256.convert(temp);

    fetchTokenDetails(privatekey);
  }

  showLoader(value) {
    setState(() {
      isShowProgress = value;
    });
  }

  fetchTokenDetails(privateKey) async {
    showLoader(true);
    FormData formData = new FormData.fromMap({
      "action":"getConsumerToken","type":"consumer","respType":"json","mercid":merchantId,"privatekey":privatekey,"email":email,"mobile":mobileNo
    });

    Dio dio = new Dio();
    dio.options.headers['Accept'] =
    'text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8';
    var response = await dio.post('https://uae-ca.airpay.ninja/api.php', data: formData);
    print("token response -->"+response.toString());
    var cardTokenResponse = cardTokenResponseFromJson(response.toString());
    //tokenData = response.data.toString();
   // tokenData = cardDetailResponse.result[0].token.toString();
    fetchCardListDetails(cardTokenResponse.result![0].token.toString());
  }

  fetchCardListDetails(String token) async {
    FormData formData = new FormData.fromMap({
      "action":"listCardAPI","type":"card","respType":"json","mercid":merchantId,"privatekey":privatekey,"token":token
    });

    Dio dio = new Dio();
    dio.options.headers['Accept'] =
    'text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8';
    var response = await dio.post('https://uae-ca.airpay.ninja/api.php', data: formData);
    print("card Details Api -->"+response.toString());
    var respData = response.data;
    print(respData);

    String cardResponse = response.toString();
    var cardDetailResponse = cardDetailResponseFromJson(cardResponse);
    print("Card Detail -->"+cardDetailResponse.toString());
    widget.cardDetailClosure!(true,cardDetailResponse);
    showLoader(false);
// Navigator.pop(context);
  }

  userCancel(String withMessage) {
    var trans = Transaction();
    trans.tRANSACTIONSTATUS = '500';
    trans.sTATUSMSG = withMessage;
  }

//   _showAlert(context, message) async {
//     await showDialog<String>(
//       context: context,
//       barrierDismissible: false,
//       builder: (BuildContext context) {
//         String title = "Airpay";
//         String message1 = message;
//         return Platform.isIOS
//             ? new CupertinoAlertDialog(
//           title: Text(title),
//           content: Text(message1),
//           actions: <Widget>[
//             new Container(
//               margin: EdgeInsets.all(8.0),
//               child: ElevatedButton(
// // padding: EdgeInsets.all(12.0),
//                 onPressed: () {
//                   Navigator.pop(context);
//                 },
// // color: Colors.blue[900],
//                 child: Text(
//                   'Okay',
//                   style: TextStyle(color: Colors.white, fontSize: 24.0),
//                 ),
//               ),
//             )
//           ],
//         )
//             : new AlertDialog(
//           title: Text(title),
//           content: Container(
//               height: 140.0,
//               width: 400.0,
//               child: ListView.builder(
//                   shrinkWrap: true,
//                   itemCount: 1,
//                   itemBuilder: (BuildContext context, int index) {
//                     return new Column(children: <Widget>[
//                       Text(message1),
//                     ]);
//                   })),
//           actions: <Widget>[
//             new Container(
//               margin: EdgeInsets.all(8.0),
//               child: ElevatedButton(
// // padding: EdgeInsets.all(2.0),
//                 onPressed: () {
//                   Navigator.pop(context);
//                 },
// // color: Colors.blue[900],
//                 child: Text(
//                   'Okay',
//                   style: TextStyle(color: Colors.white, fontSize: 24.0),
//                 ),
//               ),
//             )
//           ],
//         );
//       },
//     );
//   }

  @override
  Widget build(BuildContext context) {
    return SafeArea(
        child: Scaffold(
            appBar: AppBar(
              centerTitle: true,
              title: Image.asset(
                'assets/airpayLogo.png',
                height: 40,
                color: Colors.white,
                width: 200,
              ),
              leading: IconButton(
                icon: Icon(Icons.close),
                onPressed: () {
                  Navigator.pop(context);
                },
              ),
              backgroundColor: Colors.blue[900],
              actions: <Widget>[],
            ),
            body: isShowProgress ?
            Container(
                child: Center(
                    child: SpinKitCircle(
                      color: Colors.blue[900],
                      size: 50.0,
                    ))) : SizedBox()
        )
    );
  }
}
